//
//  MCEEditor.m
//  WebTextEditor
//
//  Created by Paul Lynch on 13/06/2010.
//  Copyright 2010 P & L Systems. All rights reserved.
//

#import "MCEEditor.h"


@implementation MCEEditor

@synthesize webView;
@synthesize config;

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
		frame.origin = NSMakePoint(0.0, 0.0);
		self.webView = [[WebView alloc] initWithFrame:frame];
		[self addSubview:webView];
		[[[webView mainFrame] frameView] setAllowsScrolling:YES];
		
		NSString *path = [[NSBundle mainBundle] pathForResource:@"mceconfig.js" ofType:nil];
		self.config = [NSString stringWithContentsOfFile:path encoding:NSUTF8StringEncoding error:nil];
		path = [[NSBundle mainBundle] pathForResource:@"editor.html" ofType:nil];
		NSString *editor = [NSString stringWithContentsOfFile:path encoding:NSUTF8StringEncoding error:nil];
		editor = [NSString stringWithFormat:editor, config];
		[[webView mainFrame] loadHTMLString:editor baseURL:[[NSBundle mainBundle] resourceURL]];
    }
    return self;
}

- (void)dealloc {
	self.webView = nil;
	self.config = nil;
	[super dealloc];
}

- (void)drawRect:(NSRect)dirtyRect {
    // Drawing code here.
}

- (void)setFrame:(NSRect)frameRect {
	[super setFrame:frameRect];
	frameRect.origin = NSMakePoint(0.0, 0.0);
	[webView setFrame:frameRect];
	// TODO: set content to correct size
}

- (NSString *)text {
	return [webView stringByEvaluatingJavaScriptFromString:@"tinyMCE.get('content').getContent();"];
}
- (void)setText:(NSString *)value {
	NSString *escaped = [value stringByReplacingOccurrencesOfString:@"'" withString:@"\\'"];
	NSString *js = [NSString stringWithFormat:@"tinyMCE.get('content').setContent('%@');", escaped];
	[webView stringByEvaluatingJavaScriptFromString:js];
}

@end
